
namespace DAE {

void                     test_set_shm_callback(int (*recv_shm_notify)(short int, int, char*, int, int, int));

struct _shm_seg_defn {
	char             name[64];
	int              size;
	void*            address;
	int              seg_id;
};
typedef struct _shm_seg_defn shm_seg_defn;

class dae
{
  public:
	dae();
	~dae();

	int                  dae_session; //server should support multiple sessions. This is normally 1.

	//pointers to shm segments. only some of these will be used.
	static void*         song;
	static void*         mixer;

	shm_seg_defn         shm_segs[10];
	void                 shm_segment_add  (char* name, int size);
	void                 shm_segment_drop (char* name);
	void                 shm_segment_reset(char* name);
	void                 shm_segment_set  (char* name, int seg_id);
	shm_seg_defn*        shm_segment_find_by_name(char* name);

	int                  debug_shm;

	int                  got_messaging;
	int                  got_shm;

	static void          set_shm_callback(int (DAE::dae::*recv_shm_notify)(short int, int, char*, int, int, int));
	static void          set_shm_callback1(int (*recv_shm_notify)(short int, int, char*, int, int, int));
	int                  recv_shm_notify(short int _notify_level, int _seg_id, char *_name, int _pages, int _rw, int _status);
	void                 shm_set_debug(int level);

	void*                shm_malloc(size_t size, struct _container* container);
	struct block*        block_init(struct _container* container, int b);
	static struct block* msg_idx_get_block(unsigned idx, int* a, int* b);

	bool                 start_messaging();
  private:
	void*                shm_get_address_next();
};

struct _gsong_pos
{
  uint32_t           beat;
  unsigned short int sub;           //subbeat (4 per beat) - not the same as core sub.
  unsigned short int tick;          //960 per sub.
};

}; // namespace DAE
