/****************************************************************************
*   S-msgs.c - part of a DAE system.
*   Copyright (C) 2004 J.H.L.Davis  jdavis@thirdsection.org.uk
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
****************************************************************************/

// Include lib built by bin/build_lib0 20040911010613501478.

#include <stdio.h>
#include <string.h>

#include "msgs.h"

using namespace DAE; 
using namespace std;
extern daeMessaging* core;
extern struct _shm_song* shm_index;
static int msg_debug = false;

extern "C" {
    int dae_set_debug(int _lev);
	int dae_send_msg(unsigned char,int,int,int,short int,unsigned char *,int);
}

//int one=1, zero=0;

// *** LEVEL -1 ***
// enum_send_msg(0,0,L,[69],2,0,0);

// MSG hooks:
//	app_send_msg(GARR,<frag>,<off>,HI,GENERAL,NOTIFY,    0,0,0,&ival1,&ival2,&ival3,0,0,0,0);
//	app_send_msg(GARR,<frag>,<off>,HI,GENERAL,NOTIFYFAIL,0,0,0,&ival1,&ival2,&ival3,0,0,0,0);

static inline int switch_transport(unsigned short int *cnt, int *frag, short int *off, unsigned char *msg, unsigned char tch);

int app_send_msg(char dest,int __frag,short int __off,char _priority,char _msg_type,
                 unsigned char _a,unsigned char _b,unsigned char _c,unsigned char _d,
                 int *_ival1,int *_ival2,int *_ival3,int *_ival4,int *_ival5,int *_ival6,double *_dval1,double *_dval2,char *_str)
{
	//copied from recorder/recmsgs.c
	printf("app_send_msg(): ");
	unsigned char tch;
	unsigned short int tsint1=0,tsint2=0;//,tsint3,tsint4,tsint5,tsint6;
	unsigned char t_str[32];

	memset(t_str,0,32);
							//app_send_msg(GTRAN,*frag,*off,HI,GENERAL,NOTIFYDONE,PLAY,0,0,&zero,0,0,0,0,0,0,0,0);
	switch (dest) {
		case GTRAN:
			switch (_msg_type) {// [18] 1:0
				case GENERAL:       // (GENERAL GTRAN)
					if (debug) printf("GENERAL ");
					t_str[0]=_a;
					switch (_a) {// [4] 2:0
						case NOTIFYDONE:        // (GENERAL GTRAN NOTIFYDONE)
							if (debug) printf("NOTIFYDONE ");
							t_str[0]=_a;
							// t_str[1]=5;
							switch (_b) {// [8] 3:0
								case STOPTRAN:      // (GENERAL GTRAN NOTIFYDONE STOPTRAN [int1:01])
									if (debug) printf("STOPTRAN ");
									t_str[1]=_b;
									tch=(unsigned char)*_ival1&0xff;
									t_str[2]=tch;
									if (debug) printf("%d ",tch);
									if (debug) printf("\n");
									break;
								case PLAY:      // (GENERAL GTRAN NOTIFYDONE PLAY [int1:01])
									if(debug) printf("PLAY ");
									t_str[1] = _b;
									tch = (unsigned char) *_ival1 & 0xff;
									t_str[2] = tch;
									if(debug) printf("%d ", tch);
									if(debug) printf("\n");
									break;
								case LOCATE_MODE:
									if(debug) printf("LOCATE_MODE ");
									t_str[1] = _b;
									tch = (unsigned char) *_ival1 & 0xff;
									t_str[2] = tch;
									if(debug) printf("%d ", tch);
									if(debug) printf("\n");
									break;
								default:
									printf("**** unhandled message!\n");
							}
							//return 1;
					}
			}
			break;
		case GMIXER:
			printf("GMIXER ");
			switch (_msg_type){
				case EVENT:     // (EVENT GMIXER)
					printf("EVENT ");
					t_str[0]=_a;
					switch (_a){
						case NOTIFY:
							printf("NOTIFY ");
							t_str[0]=_a;
							switch (_b){
								case BS:
									printf("BS (_b=%i) ", _b);
									//t_str[2]=_b;
									t_str[1]=_b;
									tsint1 = (unsigned short) *_ival1 & 0xffff;
									memcpy(&t_str[3],&tsint1,2);
									tsint2 = (unsigned short) *_ival2 & 0xffff;
									memcpy(&t_str[5],&tsint2,2);
									tch = (unsigned char) *_ival3 & 0x1;
									t_str[7]=tch;
									break;
								case CH:
									printf("CH (_b=%i) ", _b);
									switch(_c){
										case CHA_LABEL:
											printf("CHA_LABEL %s", _str);
											t_str[1]=_b;
											tsint1 = (unsigned short) *_ival1 & 0xffff;
											memcpy(&t_str[3], &tsint1, 2);
											//FIXME copy string.
											break;
										default:
											printf("unexpected _c (%i)\n", _c);
											return 0;
									}
									break;
								default:
									printf("unexpected _b (%i)\n", _b);
									return 0;
							}
							break;
						default:
							printf("unexpected _a (%i)\n", _a);
							return 0;
					}
					break;
				default:
					printf("unexpected _msg_type (%i)\n", _msg_type);
					return 0;
			}
			break;
		default:
			printf("unexpected dest (%i)\n", dest);
			return 0;
	}

	printf("sending msg... dest=%c\n", dest);
	return dae_send_msg(dest, HI, _msg_type, __frag, __off, t_str, 1);

	//printf("app_send_msg(): unhandled message!\n");
	//return 0;
}

int app_send_msg0(char dest,int __frag,short int __off,char _priority,char _msg_type,
                  unsigned char _a,unsigned char _b,unsigned char _c, unsigned char _d,
                  int* _ival1, int* _ival2, int* _ival3, int* _ival4,
                  double *_dval1, double *_dval2, char *_str)
{
	if(msg_debug) printf("app_send_msg0()...\n");
	unsigned char tch;
	//unsigned short int tsint1,tsint2,tsint3,tsint4;
	unsigned char t_str[32];

	memset(t_str,0,32);
	switch (dest) {
		case GARR:
			switch (_msg_type) {
				case GENERAL:		// (GENERAL GARR)
					t_str[0]=_a;
					switch (_a) {// [2] 2:0
						case NOTIFY:		// (GENERAL GARR NOTIFY [int4:04] [int4:04] [int1:01])
							if (debug) printf("GENERAL GARR NOTIFY trans[%u] idd[%u] obj[%u] err[%u] : ", *_ival1,*_ival2,*_ival3,*_ival4);
							//t_str[0]=_a;
							memcpy(&t_str[1],_ival1,4);
							memcpy(&t_str[5],_ival2,4);
							memcpy(&t_str[9],_ival3,4);
							tch=(unsigned char)*_ival4&0xff;
							t_str[13]=tch;
							break;
						case NOTIFYFAIL:		// (GENERAL GARR NOTIFYFAIL [int4:04] [int4:04] [int1:01])
							if (debug) printf("GENERAL GARR NOTIFY trans[%u] idd[%u] obj[%u] err[%u] : ", *_ival1,*_ival2,*_ival3,*_ival4);
							//t_str[0]=_a;
							memcpy(&t_str[1],_ival1,4);
							memcpy(&t_str[5],_ival2,4);
							memcpy(&t_str[9],_ival3,4);
							tch=(unsigned char)*_ival4&0xff;
							t_str[13]=tch;
							break;
						case NOTIFYDONE:
							if (debug) printf("GENERAL GARR NOTIFYDONE trans[%u] idd[%u] obj[%u] err[%u] : ", *_ival1,*_ival2,*_ival3,*_ival4);
							//t_str[0]=_a;
							memcpy(&t_str[1],_ival1,4);
							memcpy(&t_str[5],_ival2,4);
							memcpy(&t_str[9],_ival3,4);
							tch = (unsigned char)* _ival4 & 0xff;
							t_str[13]=tch;
							break;
					} // end GENERAL
					break;
			} // end GARR
			break;
		case GTRAN:
			if(msg_debug) printf("GENERAL GTRAN (ALL) _a=%u _b=%u idd[%u] obj[%u] err[%u]", _a, _b, *_ival2, *_ival3, *_ival4);
			t_str[0] = _a;
			t_str[1] = _b;
			memcpy(&t_str[5], _ival2, 4);
			memcpy(&t_str[9], _ival3, 4);
			tch = (unsigned char) *_ival4 & 0xff; t_str[13] = tch; //err
			break;
		default:
			printf("*** unhandled msg!!\n");
	}
	printf("\n");

	return dae_send_msg(dest,HI,_msg_type,__frag,__off,t_str,1);
}

// *** LEVEL 0 ***
// app_recv_msg(): built to recv: GENERAL for SONG
// msgs to process arrive here
// return 1 to indicate the message has been processed
int
app_recv_msg(unsigned char *id, unsigned short int *cnt, int *frag, short int *off, unsigned char *msg)
{
	/*
	frag - dont know - i think we can ignore it.
	off  - dont know - i think we can ignore it.
	msg  - 32 bytes?
	*/
    debug = 1; //FIXME why isnt the global value reaching us here?
    if (debug) printf("%sapp_recv_msg()%s\n", green, white);
	unsigned char  tch=0;
	unsigned short tsint1=0, tsint2=0;
	unsigned int   ival1=0, ival2=0;
	int            err=0;
	int            trans_id = 0;
	double         tdb1=0;//,tdb2=0;
	char           t_str[32];
	uint32_t       obj_type;

	memcpy(&trans_id, &msg[4], 4); //oh dear, trans_id is not always at [4] ?

	// if we don't have any SHM then ignore any messages !!
	// NB will have to define this better ....
	if (core->got_shm==0) return 1;

	int transport_return = 0;

	switch (*id){
		case TRAN:
			printf("app_recv_msg(): id=TRAN\n");
			transport_return = switch_transport(cnt, frag, off, msg, tch);
			return transport_return;
			break;

		case REC: //recorder
			if (debug) printf("app_recv_msg(): REC ");
			switch (msg[0]) {
				case GENERAL:		// GENERAL REC
					printf("GENERAL ");
					switch (msg[1]) {
						case 1: //SET:  //sometimes SET is 1, sometimes 5
							if (debug) printf("SET ");
							switch (msg[2]) {
								case RUNPAR:        // (GENERAL REC SET RUNPAR)
									if (debug) printf("RUNPAR ");
									switch (msg[3]) {
										case PB_DIRECTION:      // (GENERAL REC SET RUNPAR PB_DIRECTION [int1:01])
											memcpy(&tsint1,&msg[4],4);
											ival1=(int)tsint1;
											memcpy(&tsint2,&msg[8],4);
											ival2=(int)tsint2;
											if (debug) printf("PB_DIRECTION ival1=%i ival2%i\n", ival1, ival2);
											switch (ival1) {
												case 1:
													//core->session->request_transport_speed (+2.0f);
													core->ff(0);
													return 1;
												case 2:
													core->rew(0);
													return 1;
												default:
													printf("***unexpected ival1 value (%i)\n", ival1); return 0;
													return 0;
											}
											return core->rew(ival1);
									}
							}
						default:
							printf("%sunmatched msg[1]=%i%s\n", yellow, msg[1], white);
							return 0;
					}
				default:
					printf("%sunmatched msg[0]=%i%s\n", yellow, msg[0], white);
					return 0;
			}
			if (debug) printf("***unhandled!\n");
			return 0;

		case SONG:
			printf("%s(): id=SONG\n", __func__);

			switch (msg[0]) {// [18] 1:0
				case GENERAL:		// (GENERAL SONG)
					printf("app_recv_msg(): 0=GENERAL\n");
					switch (msg[1]) {// [5] 2:0
						case ADD:		// (GENERAL SONG ADD [int4:04] [int1:01] <data>
							// _b=msg[1];
							if (debug) printf("\n// (GENERAL SONG ADD [int4:04] [int1:01] <data>\n");
							tch=msg[2];
							if (debug) printf("tch=%d<\n",tch);
							// msg[3] is spare
							memcpy(&ival1, &msg[4],4);	// <-- transacation ID
							trans_id = (int)ival1;
							if (debug) printf("ival1=%u<\n",ival1);
							if (debug) printf("frag.off=%d.%d\n",*frag,*off);

							if (tch==DAE_OBJECT_TRACK){        dae_msg_add_track(trans_id, frag, off, (char*)&msg[8]); }
							if (tch==DAE_OBJECT_PART) { err = !dae_msg_add_part (trans_id, frag, off, (char*)&msg[8]); }
							if (tch==DAE_OBJECT_FILE) {        dae_msg_add_file (trans_id, frag, off, (char*)&msg[8]); }

							if(err)	app_send_msg0(GARR, *frag,*off, HI,GENERAL, NOTIFYFAIL,0,0,0, &trans_id, &zero, &zero, &err,0,0,0);
							return 1;
						case DEL:		// (GENERAL SONG DEL [int4:04] [char:20])
							// _b=msg[1];
							if (debug) printf("\n// (GENERAL SONG DEL [int4:04] [char:20])\n");

							memcpy(&ival1,&msg[4],4);	// <-- transacation ID
							if (debug) printf("ival1=%u<\n",ival1);
							memcpy(&ival2,&msg[8],4);	// <-- obj_id
							if (debug) printf("ival2=%x<\n",ival2);
							//if (debug) printf("frag.off=%d.%d\n",*frag,*off);

							obj_type = msg_get_obj_type(ival2);
							switch (obj_type) {
								case ARDOUR_TYPE_TRACK:
									//printf("%x %x\n", ~ARDOUR_TYPE_MASK2, ival2 & ~ARDOUR_TYPE_MASK2);
									dae_msg_del_track(ival1, ival2 & ~ARDOUR_TYPE_MASK);
									break;
								case ARDOUR_TYPE_FILE:
									dae_msg_del_file(ival1, ival2 & ~ARDOUR_TYPE_MASK);
									break;
								case ARDOUR_TYPE_PART:
									dae_msg_del_part(ival1, ival2 & ~ARDOUR_TYPE_MASK);
									break;
								default:
									printf("%s(): unexpected object type (%x)\n", __func__, obj_type);
							}
							return 1;
						case MOD:		// (GENERAL SONG MOD [int4:04] [char:20])
							// _b=msg[1];
							memcpy(&tsint1,&msg[2],4);
							ival1=(int)tsint1;
							memcpy(t_str,&msg[6],20); t_str[20]=0;

							return 1;
						case GET:		// (GENERAL SONG GET [int4:04] [char:20])
							// _b=msg[1];
							memcpy(&tsint1,&msg[2],4);
							ival1=(int)tsint1;
							memcpy(t_str,&msg[6],20); t_str[20]=0;
							// set back NOTIFY msg
							//app_send_msg(SONG,<frag>,<off>,HI,GENERAL,NOTIFY,0,0,0,&ival1,0,0,0,0,0,0);
							// OR send back a xxxFAIL msg
							//app_send_msg(SONG,<frag>,<off>,HI,GENERAL,GETFAIL,0,0,0,&ival1,0,0,0,0,0,0);

							return 1;		// maybe do something just before this ?
						case SET:		// (GENERAL SONG SET [int4:04] [char:20])
							// _b=msg[1];
							if (debug) printf("\n// (GENERAL SONG SET [int4:04] [int1:01] <data>\n");
							//tch=msg[2];
							//if (debug) printf("tch=%d<\n",tch);
							//msg[3] is spare
							memcpy(&ival1,&msg[4],4);	// <-- transacation ID
							if (debug) printf("  ival1=%u<\n",ival1);

							if (debug) printf("  frag.off=%d.%d\n",*frag,*off);
							/*
							int kk; for(kk=0; kk<12; kk++){
								char cc = msg[kk];
								printf("%i=%u\n", kk, cc);
							}
							*/
							dae_msg_set_obj(ival1,frag,off,&msg[8]);
							
							return 1;
					} // h2
					printf("  unhandled message?...msg[1]=%i\n", msg[1]);
					//return 1;		// maybe do something just before this ?
					return 0;

				break;
			} // h1

		case AMIXER:
			printf("AMIXER ");
			switch (msg[0]){
				case EVENT:     // (EVENT AMIXER)
					if (debug) printf("EVENT ");
					switch (msg[1]){
						case 1: //SET:
							switch (msg[2]){
								case CH:
									printf("CH ");
									memcpy(&tsint1,&msg[3],2);
									ival1=(unsigned)tsint1;
									ival2=(unsigned)tsint2;
									switch (msg[5]){
										case LEV:
											memcpy(&tdb1, &msg[6],8);
											core->mixer_set_level(ival1, tdb1);
											return 1;
										case CHA_LABEL:
											memcpy(t_str, &msg[6],20); t_str[20]=0;
											printf("CHA_LABEL. check! '%s'\n", t_str);
											core->route_set_name(ival1, t_str);
											return 0;
										case PLUGIN_SEL:
											//memcpy(&trans_id, &msg[1], 4);
											//memcpy(&trans_id, &msg[2], 4); //guessing...
											//memcpy(&trans_id, &msg[3], 4); //guessing...
											//memcpy(&trans_id, &msg[4], 4);
											memcpy(&trans_id, &msg[5], 4);
											memcpy(t_str, &msg[6],20); t_str[20]=0;
											printf("PLUGIN_SEL. '%s'\n", t_str);
											if(!core->mixer_set_plugin(ival1, ival2, t_str)){
												app_send_msg0(GARR, *frag, *off, HI, GENERAL, NOTIFY,0,0,0, &trans_id, &zero, &zero, &err,0,0,0);
											}else{
												app_send_msg0(GARR,*frag,*off,HI,GENERAL,NOTIFYFAIL,0,0,0, &trans_id, &zero, &zero, &err,0,0,0);
											} 
											return 0;
										default:
											printf("*** unhandled. msg[5]=%i\n", msg[5]);
											return 0;
									}

									break;
								case BS:
									if (debug) printf("BS\n");

									//memcpy(&tsint1, &msg[4], 2);     //bus
									//if (debug) printf("bus=%u ",tsint1);

									//memcpy(&tsint2,&msg[6],2);
									//if (debug) printf("ch=%u ",tsint2);
									//tch=msg[8];
									//ival3=(unsigned int)tch;
									//if (debug) printf("%u %u ",tch,ival3);

									dae_msg_set_output(0,frag,off,&msg[4]);
									return 1;

								default:
									printf("app_recv_msg(): unhandled AMIXER EVENT SET message! msg[2]=%i\n", msg[2]);
									return 0;
							}
						default:
							printf("app_recv_msg(): unhandled AMIXER EVENT message! msg[1]=%i\n", msg[1]);
							return 0;
					}
				default:
					printf("app_recv_msg(): unhandled AMIXER message!\n");
					return 0;
			}
	}

	fprintf(stderr," ** UNKNOWN MSG ***\n");
	return 1;
}

static inline int
switch_transport(unsigned short int *cnt, int *frag, short int *off, unsigned char *msg, unsigned char tch)
{
	unsigned short int tsint1=0,tsint2=0,tsint3=0;//,tsint4=0,tsint5=0,tsint6=0;
	unsigned int ival1=0,ival2=0,ival3=0;//,ival4=0,ival5=0,ival6=0;
	//if(msg_debug) printf("switch_transport()...%i %i\n", msg[0], GENERAL);
	int return_idx =  0;
							int oid        =  0;
	int trans_id  = 0;
							int err        =  0;
	memcpy(&trans_id, &msg[4], 4);

	switch (msg[0]) {
		case GENERAL:
			if(msg_debug) printf("GENERAL TRAN ");
			switch (msg[1]) {
				case DO:
					if(msg_debug) printf("DO ");
					switch (msg[2]) {
						case PLAY:      // GENERAL TRAN DO PLAY
							if(msg_debug) printf("PLAY\n");
							//core->session->request_roll();     //doesnt exist!!!
							//core->session->start_transport();  //private
							//printf("switch_transport(): play: locating to %u\n", core->session->transport_frame());
							core->session->request_locate(core->session->transport_frame(), true);
							app_send_msg(GTRAN,*frag,*off,HI,GENERAL,NOTIFYDONE,PLAY,0,0,&zero,0,0,0,0,0,0,0,0);
							return 1;
						case STOPTRAN:
							if (msg_debug) printf("STOPTRAN\n");
							if (core->got_shm) core->session->request_stop();
							app_send_msg(GTRAN,*frag,*off,HI,GENERAL,NOTIFYDONE,STOPTRAN,0,0,&zero,0,0,0,0,0,0,0,0);
							return 1;
						case LOCATE:        // (GENERAL TRAN DO LOCATE [int4:04] [int4:04] [int4:04])
							if (msg_debug) printf("LOCATE ");
							memcpy(&tsint1,&msg[3],4);
							ival1=(int)tsint1;
							if (msg_debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[7],4);
							ival2=(int)tsint2;
							if (msg_debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[11],4);
							ival3=(int)tsint3;
							if(msg_debug) printf("%d ",ival3);
							if(msg_debug) printf("\n");

							struct _gsong_pos pos;
							pos.beat = ival1;
							pos.sub  = ival2;
							pos.tick = ival3;
							core->session->request_locate(core->gpos2samples(&pos), false);
							return 1;
						default:
							//session->request_transport_speed (-1.0f);
							if (msg_debug) printf(" **UNKNOWN \n");
					}
					break;
				case 1:
					if(msg_debug) printf("1 ");
					switch (msg[2]) {
						case LOCATE_MODE:		// (GENERAL GTRAN NOTIFYSET LOCATE_MODE [int1:01] [int1:01])
							if(msg_debug) printf("LOCATE_MODE ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if(msg_debug) printf("%d ", ival1);

							tch = msg[4];
							ival2 = (int)tch;
							if(msg_debug) printf("%d\n", ival2);
							
							if(msg_debug) printf("\n ival1=%i setting: %i\n", ival1, ival1 ? true : false);
							core->set_cycle_onoff(ival1 ? true : false);
							
							app_send_msg0(GTRAN,*frag,*off,HI,GENERAL,NOTIFYSET,LOCATE_MODE,0,0, &trans_id, &oid, &return_idx, &err,0,0,0);
							return 1;
						default:
							if(msg_debug) printf(" **UNKNOWN \n");
					}

				//message below here may be wrong:
				/*
				case NOTIFYSET:		// (GENERAL GTRAN NOTIFYSET)
					if(msg_debug) printf("TRAN NOTIFYSET ");
					// _b=msg[1];
					// msg[1]=3;
					switch (msg[2]) {// [10] 3:0
						case AROS:		// (GENERAL GTRAN NOTIFYSET AROS [int1:01] [int1:01])
							if (debug) printf("AROS ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case AAOS:		// (GENERAL GTRAN NOTIFYSET AAOS [int1:01] [int1:01])
							if (debug) printf("AAOS ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOCL:		// (GENERAL GTRAN NOTIFYSET LOCL [int1:01] [int1:01])
							if (debug) printf("LOCL ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOCR:		// (GENERAL GTRAN NOTIFYSET LOCR [int1:01] [int1:01])
							if (debug) printf("LOCR ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case DROPIN:		// (GENERAL GTRAN NOTIFYSET DROPIN [int1:01] [int1:01])
							if (debug) printf("DROPIN ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case DROPOUT:		// (GENERAL GTRAN NOTIFYSET DROPOUT [int1:01] [int1:01])
							if (debug) printf("DROPOUT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_SPP:		// (GENERAL GTRAN NOTIFYSET LOC_SPP [int4:04] [int4:04] [int4:04] [int1:01])
							if (debug) printf("LOC_SPP ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],4);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[7],4);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[11],4);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							tch=msg[15];
							ival4=(int)tch;
							if (debug) printf("%d ",ival4);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_TIME:		// (GENERAL GTRAN NOTIFYSET LOC_TIME [int2:02] [int2:02] [int2:02] [int2:02] [int2:02] [int2:02])
							if (debug) printf("LOC_TIME ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],2);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[5],2);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[7],2);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							memcpy(&tsint4,&msg[9],2);
							ival4=(int)tsint4;
							if (debug) printf("%d ",ival4);
							memcpy(&tsint5,&msg[11],2);
							ival5=(int)tsint5;
							if (debug) printf("%d ",ival5);
							memcpy(&tsint6,&msg[13],2);
							ival6=(int)tsint6;
							if (debug) printf("%d ",ival6);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_TC:		// (GENERAL GTRAN NOTIFYSET LOC_TC [int2:02] [int2:02] [int2:02] [int2:02] [int2:02] [int1:01])
							if (debug) printf("LOC_TC ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],2);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[5],2);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[7],2);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							memcpy(&tsint4,&msg[9],2);
							ival4=(int)tsint4;
							if (debug) printf("%d ",ival4);
							memcpy(&tsint5,&msg[11],2);
							ival5=(int)tsint5;
							if (debug) printf("%d ",ival5);
							tch=msg[13];
							ival6=(int)tch;
							if (debug) printf("%d ",ival6);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
					} // end NOTIFYSET
					return 1;		// maybe do something just before this ?

				case NOTIFYGET:		// (GENERAL GTRAN NOTIFYGET)
					if (debug) printf("NOTIFYGET ");
					// _b=msg[1];
					// msg[1]=4;
					switch (msg[2]) {// [10] 3:0
						case LOCATE_MODE:		// (GENERAL GTRAN NOTIFYGET LOCATE_MODE [int1:01] [int1:01])
							if (debug) printf("LOCATE_MODE ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							//transport_cycle_toggle_cb();
							return 1;
						case AROS:		// (GENERAL GTRAN NOTIFYGET AROS [int1:01] [int1:01])
							if (debug) printf("AROS ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case AAOS:		// (GENERAL GTRAN NOTIFYGET AAOS [int1:01] [int1:01])
							if (debug) printf("AAOS ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOCL:		// (GENERAL GTRAN NOTIFYGET LOCL [int1:01] [int1:01])
							if (debug) printf("LOCL ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOCR:		// (GENERAL GTRAN NOTIFYGET LOCR [int1:01] [int1:01])
							if (debug) printf("LOCR ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case DROPIN:		// (GENERAL GTRAN NOTIFYGET DROPIN [int1:01] [int1:01])
							if (debug) printf("DROPIN ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case DROPOUT:		// (GENERAL GTRAN NOTIFYGET DROPOUT [int1:01] [int1:01])
							if (debug) printf("DROPOUT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_SPP:		// (GENERAL GTRAN NOTIFYGET LOC_SPP [int4:04] [int4:04] [int4:04] [int1:01])
							if (debug) printf("LOC_SPP ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],4);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[7],4);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[11],4);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							tch=msg[15];
							ival4=(int)tch;
							if (debug) printf("%d ",ival4);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_TIME:		// (GENERAL GTRAN NOTIFYGET LOC_TIME [int2:02] [int2:02] [int2:02] [int2:02] [int2:02] [int2:02])
							if (debug) printf("LOC_TIME ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],2);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[5],2);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[7],2);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							memcpy(&tsint4,&msg[9],2);
							ival4=(int)tsint4;
							if (debug) printf("%d ",ival4);
							memcpy(&tsint5,&msg[11],2);
							ival5=(int)tsint5;
							if (debug) printf("%d ",ival5);
							memcpy(&tsint6,&msg[13],2);
							ival6=(int)tsint6;
							if (debug) printf("%d ",ival6);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOC_TC:		// (GENERAL GTRAN NOTIFYGET LOC_TC [int2:02] [int2:02] [int2:02] [int2:02] [int2:02] [int1:01])
							if (debug) printf("LOC_TC ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],2);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[5],2);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[7],2);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							memcpy(&tsint4,&msg[9],2);
							ival4=(int)tsint4;
							if (debug) printf("%d ",ival4);
							memcpy(&tsint5,&msg[11],2);
							ival5=(int)tsint5;
							if (debug) printf("%d ",ival5);
							tch=msg[13];
							ival6=(int)tch;
							if (debug) printf("%d ",ival6);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
					} // end NOTIFYGET
					return 1;		// maybe do something just before this ?

				case NOTIFYDONE:		// (GENERAL GTRAN NOTIFYDONE)
					if (debug) printf("NOTIFYDONE ");
					// _b=msg[1];
					// msg[1]=5;
					switch (msg[2]) {// [8] 3:0
						case STOPTRAN:		// (GENERAL GTRAN NOTIFYDONE STOPTRAN [int1:01])
							if (debug) printf("STOPTRAN ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
		//transport_stop_cb();
							return 1;		// maybe do something just before this ?
						case PLAY:		// (GENERAL GTRAN NOTIFYDONE PLAY [int1:01])
							if (debug) printf("PLAY ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
		//transport_play_cb();
							return 1;		// maybe do something just before this ?
						case PLAY_ARM:		// (GENERAL GTRAN NOTIFYDONE PLAY_ARM [int1:01])
							if (debug) printf("PLAY_ARM ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case RECPLAY:		// (GENERAL GTRAN NOTIFYDONE RECPLAY [int1:01])
							if (debug) printf("RECPLAY ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LOCATE:		// (GENERAL GTRAN NOTIFYDONE LOCATE [int4:04] [int4:04] [int4:04] [int1:01])
							if (debug) printf("LOCATE ");
							// _c=msg[2];
							memcpy(&tsint1,&msg[3],4);
							ival1=(int)tsint1;
							if (debug) printf("%d ",ival1);
							memcpy(&tsint2,&msg[7],4);
							ival2=(int)tsint2;
							if (debug) printf("%d ",ival2);
							memcpy(&tsint3,&msg[11],4);
							ival3=(int)tsint3;
							if (debug) printf("%d ",ival3);
							tch=msg[15];
							ival4=(int)tch;
							if (debug) printf("%d ",ival4);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case DOUBLE_SPEED:		// (GENERAL GTRAN NOTIFYDONE DOUBLE_SPEED [int1:01])
							if (debug) printf("DOUBLE_SPEED ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case HALF_SPEED:		// (GENERAL GTRAN NOTIFYDONE HALF_SPEED [int1:01] [int1:01])
							if (debug) printf("HALF_SPEED ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case REV_PB_DIRECTION:		// (GENERAL GTRAN NOTIFYDONE REV_PB_DIRECTION [int1:01])
							if (debug) printf("REV_PB_DIRECTION ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
					} // end NOTIFYDONE
					return 1;		// maybe do something just before this ?
					*/

				case NOTIFYJT:		// (GENERAL GTRAN NOTIFYJT)
					if(msg_debug) printf("NOTIFYJT ");
					// _b=msg[1];
					// msg[1]=6;
					/*
					switch (msg[2]) {// [5] 3:0
						case STARTJT:		// (GENERAL GTRAN NOTIFYJT STARTJT [int1:01])
							if (debug) printf("STARTJT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case STOPJT:		// (GENERAL GTRAN NOTIFYJT STOPJT [int1:01])
							if (debug) printf("STOPJT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case LINKJT:		// (GENERAL GTRAN NOTIFYJT LINKJT [int1:01] [int1:01])
							if (debug) printf("LINKJT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							tch=msg[4];
							ival2=(int)tch;
							if (debug) printf("%d ",ival2);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case MASTERJT:		// (GENERAL GTRAN NOTIFYJT MASTERJT [int1:01])
							if (debug) printf("MASTERJT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
						case RELEASEJT:		// (GENERAL GTRAN NOTIFYJT RELEASEJT [int1:01])
							if (debug) printf("RELEASEJT ");
							// _c=msg[2];
							tch=msg[3];
							ival1=(int)tch;
							if (debug) printf("%d ",ival1);
							if (debug) printf("\n");
							return 1;		// maybe do something just before this ?
					} // end NOTIFYJT
					return 1;		// maybe do something just before this ?
				*/
				default:
					printf("** unexpected message msg[1]=%i\n", msg[1]);

			} // end GTRAN
			return 1;		// maybe do something just before this ?
		default:
			printf("** unexpected message msg[0]=%i\n", msg[0]);
	} // end switch msg[0] (GENERAL)
	printf("     done\n");
	return 0;
}


//this can be used to construct custom messages.
int
app_recv_str(unsigned char *msg,int sz)
{
	int i;
	char *ptr;
	
	ptr = (char*)msg;
	if (strstr(ptr,"debug")==ptr)
		{
		if (strlen((char*)msg)>6)
			{
			printf("***CLI: %s",msg);
			i=atoi((char*)&msg[6]);
			if ((i>=0) && (i<100)) dae_set_debug(i);
			}
		}
	return 1;
}


uint32_t
msg_get_obj_type(uint32_t msg_val)
{
	//printf("v=%x\nm=%x\nr=%x\n", msg_val, ARDOUR_TYPE_MASK,  msg_val & ARDOUR_TYPE_MASK);
	return msg_val & ARDOUR_TYPE_MASK;
}


