/****************************************************************************
*   S-msgs.h - part of a DAE system.
*   Copyright (C) 2004 J.H.L.Davis  jdavis@thirdsection.org.uk
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
****************************************************************************/

/*

*********note: the codes for defines of this type: __DAE_DEFINE_APP_MSGS_D_, are defined in event.list, eg E is for MIXER

*/

#ifndef __DAE_DEFINE_APP_TYPES_
#define __DAE_DEFINE_APP_TYPES_
// APP values
#define CORE 'A'		// CORE APP value
#define REC 'B'		// REC APP value
#define VREC 'C'		// VREC APP value
#define TRAN 'D'		// TRAN APP value
#define AMIXER 'E'		// AMIXER APP value
#define MMIXER 'F'		// MMIXER APP value
#define VMIXER 'G'		// VMIXER APP value
#define AROUTER 'H'		// AROUTER APP value
#define VROUTER 'I'		// VROUTER APP value
#define MROUTER 'J'		// MROUTER APP value
#define GMIXER 'K'		// GMIXER APP value
#define GARR 'L'		// GARR APP value
#define GTRAN 'M'		// GTRAN APP value
#define GMET 'N'		// GMET APP value
#define IPL 'X'		// IPL APP value
#define IPC 'Y'		// IPC APP value
#define CON 'Z'		// CON APP value
#define SONG 'S'		// SONG APP value
#endif

#ifndef __DAE_DEFINE_SPECIAL_TYPES_
#define __DAE_DEFINE_SPECIAL_TYPES_
// special values for ALL
#define ALLC 0xFF		// int1 all values
#define ALLS 0xFFFF		// int2 all values
#define ALLI 0xFFFFFFFF		// int4 all values
#define HI 1		// int1 all values
#define LO 2		// int1 all values
#endif

#ifndef __DAE_DEFINE_APP_MSGS_D_
#define __DAE_DEFINE_APP_MSGS_D_
// Defines - A values
#define D_SET            1  // [direct:1]
#define D_GET            2  // [direct:1]
#define DO               3  // [direct:1]
#define JT               4  // [direct:1]

// Defines - B values
#define LOCATE_MODE      1  // [int1:1]
#define AROS             2  // [int1:1]
#define AAOS             3  // [int1:1]
#define LOCL             4  // [int1:1]
#define LOCR             5  // [int1:1]
#define DROPIN           6  // [int1:1]
#define DROPOUT          7  // [int1:1]
#define LOC_SPP          8  // [int4:4]
#define LOC_TIME         9  // [int2:2]
#define LOC_TC           10 // [int2:2]
#define STOPTRAN         20 //
#define PLAY             21 //
#define PLAY_ARM         22 //
#define RECPLAY          23 //
#define LOCATE           24 // [int4:4]
#define DOUBLE_SPEED     25 //
#define HALF_SPEED       26 //
#define REV_PB_DIRECTION 27 //
#define STARTJT          30 //
#define STOPJT           31 //
#define LINKJT           32 // [int1:1]
#define MASTERJT         33 //
#define RELEASEJT        34 //
#endif

//############# mixer ##############
#ifndef __DAE_DEFINE_APP_MSGS_K_
#define __DAE_DEFINE_APP_MSGS_K_
// Defines - A values
//#define NOTIFY           1  // [direct:0]
#define SHM              2  // [direct:0]
#define GETFAIL          2  // [direct:0]
#define SETFAIL          3  // [direct:0]

// Defines - B values
#define LOG_LEVEL        1  // [int1:1]
//#define NOTIFY           1  // [string:10]
#define DO_CREATE        2  // [string:10]
#define DO_DESTROY       3  // [string:10]
#define DO_IMPORT        4  // [string:10]
#define DO_DROP          5  // [string:10]
#define NOTIFY_REQ_CREATE_FAIL 6    // [string:10]
#define NOTIFY_REQ_DESTROY_FAIL 7   // [string:10]
#define NOTIFY_REQ_IMPORT_FAIL 8    // [string:10]
#define NOTIFY_REQ_DROP_FAIL 9  // [string:10]
#define NUM_JACK_IPS     1  // [int4:4]
#define NUM_JACK_OPS     2  // [int4:4]
#define NUM_VIS          3  // [int4:4]
#define MAS_MUTE         4  // [bool:1]
#define MON_MUTE         5  // [bool:1]
#define MON_DIM          6  // [bool:1]
#define SOLO_MODE        7  // [bool:1]
#define OUT_SEL          8  // [bool:1]
#define MAS_LEV          9  // [double:8]
#define MON_LEV          10 // [double:8]
#define MON_DIM_LEV      11 // [double:8]
#define IROUTE           12 // [int2:2]
#define OROUTE           13 // [int2:2]
#define CH               14 // [int2:2]
#define BS               15 // [int2:2]

// Defines - C values
#define TYPE             1  //
#define INS              2  // [bool:1]
#define MUTE             3  // [bool:1]
#define SOLO             4  // [bool:1]
#define SDEF             5  // [bool:1]
#define CHA_LABEL        6  // [string:15]
#define SRC_LABEL        7  // [string:15]
#define LEV              8  // [double:8]
#define BUSS             9  // [int2:2]
#define PLUGIN_SEL      10  // [string:15]

// Defines - D values
#define IN_USE           1  // [int1:1]
#define FEED             2  // [int1:1]
#define PAN_ON           3  // [bool:1]
#define FDR_ON           4  // [bool:1]
#define PAN_POLY         5  // [int1:1]
#define PAN_FUNC         6  // [bool:1]
#define IPAN_VAL         7  // [int4:4]
#define DPAN_VAL         8  // [double:8]
#define SEND_VAL         9  // [double:8]
#endif





#ifndef __DAE_DEFINE_APP_MSGS_L_
#define __DAE_DEFINE_APP_MSGS_L_
// Defines - A values
//#define NOTIFY           1	// [int4:4]
//#define NOTIFYFAIL       2	// [int4:4]
//#define NOTIFYSET        3  // [direct:1]
//#define NOTIFYGET        4  // [direct:1]
//#define NOTIFYDONE       5  // [direct:1]
/*
#define NOTIFYSTART      6  // [direct:1]
#define NOTIFYSTOP       7  // [direct:1]

// Defines - B values
//#define TRK              1    // [direct:1]   //???? also in dae_song_client.h
#define REC2AR           2  // [direct:1]
#define REC2MR           3  // [direct:1]
*/
#define RUNPAR           4  // [direct:1]
/*
#define MISC             1  // [direct:1]

// Defines - C values
#define MON_MODE         1  // [int1:1]
#define REC_MODE         2  // [int1:1]
#define MUTE             3  // [int1:1]
#define ARM              4  // [int1:1]
#define LOCK             5  // [int1:1]
#define CHAN             6  // [int1:1]
#define NUM_IN_PORTS     1  // [int1:1]
#define NUM_OUT_PORTS    2  // [int1:1]
*/
#define PB_DIRECTION     1  // [int1:1]
/*
#define AUDIOFOLDER      2  // [string:256]
#define SPEED            3  // [int1:1]
#define TC_TYPE          4  // [int1:1]
#define BPM              5  // [double:8]
#define TIME_SIG         6  // [int1:1]
#define AUD_MON          1  // [int1:1]
#define AUTO_TEST        2  // [int1:1]
#define GEN_TONE         3  // [int4:4]
#define AUDITION         4  // [string:256]
#define STOP_AUD         5  // [int1:1]
#define RELEASEFILE      6  // [string:256]
#define OPENFILE         7  // [string:256]
#define REOPENFILE       8  // [string:256]
*/
#endif

#ifndef __DAE_DEFINE_APP_MSGS_M_
#define __DAE_DEFINE_APP_MSGS_M_
// Defines - A values
//#define NOTIFYSET        3  // [direct:1]
//#define NOTIFYGET        4  // [direct:1]
//#define NOTIFYDONE       5  // [direct:1]
#define NOTIFYJT         6  // [direct:1]
#endif

#ifndef __DAE_DEFINE_APP_MSGS_S_
#define __DAE_DEFINE_APP_MSGS_S_
// Defines - A values
#define ADD              1	// [int1:1]
#define DEL              2	// [int4:4]
#define MOD              3	// [int4:4]
#define GET              4	// [int4:4]
#define SET              5	// [int4:4]
#endif

#ifndef __DAE_DEFINE_APP_MSGS_L_
#define __DAE_DEFINE_APP_MSGS_L_
// Defines - A values
//#define NOTIFY           1	// [int4:4]
//#define NOTIFYFAIL       2	// [int4:4]
#endif

#ifndef __DAE_DEFINE_APP_MSGS_S_
#define __DAE_DEFINE_APP_MSGS_S_
// Defines - A values
#define ADD              1	// [int1:1]
#define DEL              2	// [int4:4]
#define MOD              3	// [int4:4]
#define GET              4	// [int4:4]
#define SET              5	// [int4:4]
#endif

//add-hoc additions
#define ANNOUNCE_NEW_OBJECT 9


extern "C" {
int app_send_msg(char dest,int __frag,short int __off,char _priority,char _msg_type,
                 unsigned char _a,unsigned char _b,unsigned char _c,unsigned char _d,
                 int *_ival1,int *_ival2,int *_ival3,int *_ival4,int *_ival5,int *_ival6,double *_dval1,double *_dval2,char *_str);
int app_send_msg0(char,int,short int,char,char,unsigned char,unsigned char,unsigned char,
					unsigned char,int *,int *,int *,int *,double *,double *,char *);
int app_recv_msg(unsigned char *id,unsigned short int *cnt,int *frag,short int *off,unsigned char *msg);
int app_recv_str(unsigned char *msg,int sz);

uint32_t msg_get_obj_type(uint32_t msg_val);
void     msg_printf(unsigned char* msg);
}

