#define UTILS_CC

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdint.h>

#include "utils.h"

extern struct _shm_song* shm_index;
extern char white[];
extern char green[];

extern "C" {

void
errprintf(char *format, ...)
{
  //fn prints an error string, then passes arguments on to vprintf.

  va_list argp; //points to each unnamed arg in turn

  printf("%s ", smerr);

  va_start(argp, format); //make ap (arg pointer) point to 1st unnamed arg

  vprintf(format, argp);

  va_end(argp); //clean up
}


void
warnprintf(char *format, ...)
{
  //fn prints a warning string, then passes arguments on to vprintf.

  printf("%s ", smwarn);

  va_list argp;           //points to each unnamed arg in turn
  va_start(argp, format); //make ap (arg pointer) point to 1st unnamed arg
  vprintf(format, argp);
  va_end(argp);           //clean up
}

void
printf_ok(char *format, ...)
{
  va_list argp; //points to each unnamed arg in turn

  va_start(argp, format); //make ap (arg pointer) point to 1st unnamed arg
  vprintf(format, argp);
  va_end(argp);           //clean up

  printf("                      [ %sok%s ]", green, white);
}

} //end extern C.

