namespace DAE {

/*static*/ void 
testFreeFunc(void* ptr)
{
	//we get both shm and normal memory addresses.

	//printf("testFreeFunc(): ptr=%p\n", ptr);
	//printf("f");
	if((int)ptr>(int)core->song && (int)ptr < ((int)core->song + SONG_SEGMENT_SIZE*SHM_BLOCK_SIZE)){
		//printf("testFreeFunc(): shm address. Not freeing.\n");
		return;
	}
	//free(ptr);
}

/*static*/ void*
testMallocFunc(size_t size)
{
	//printf("testMallocFunc\n");
	return malloc(size);
}

/*static*/ void*
testReallocFunc(void* ptr, size_t size)
{
	return realloc(ptr, size);
}

/*static*/ char*
testStrdupFunc(const char* str)
{
	return strdup(str);
}

#ifdef SHM_XML
GList*
get_region_list()
{
	/*
	maybe silly copying track nodes into another linked list, but there you go...

	nb: make sure it isnt the playlist you want!

	*/
	printf("get_region_list()...\n");
    xmlNode* node = NULL;
    xmlNode* part_node = NULL;
	GList*   part_list = NULL;

	xmlNode* root_node = (xmlNode*)((unsigned int)shm_index->session + (unsigned int)core->song);
	//printf("get_region_list(): shm_index=%p session=%p root_node=%p.\n", shm_index, shm_index->session, root_node);
	if((node = DAE::get_named_child(root_node->children, "Regions"))){ //get the Routes node.
		printf("%s(): regions node: %p  - session=%p\n", __func__, node, shm_index->session);
		if (!node->children) return NULL;
		for (part_node = node->children; part_node; part_node = part_node->next ? (xmlNode*)part_node->next : NULL) {
			//if (!track_node) return 0;
			if (part_node->type == XML_ELEMENT_NODE){
				//printf("sml_count_children(): child name: %s\n", (char*)sml_translate_address((void*)cur_node->name));
				xmlNode* region;
				if((region = DAE::get_named_child(part_node, "Region"))){
					//printf("ardour_get_part_list(): region!\n");
					if (region->type == XML_ELEMENT_NODE){
						part_list = g_list_append(part_list, region);
					}
				}
			}
		}
	}
	printf("get_region_list(): num parts found: %i\n\n", g_list_length(part_list));
	return part_list;
}


GList*
get_playlist_nodelist()
{
	/*
	maybe silly copying track nodes into another linked list, but there you go...

	*/
	printf("get_playlist_nodelist()...\n");
    //xmlNode* node = NULL;
    xmlNode* playlist = NULL;
    xmlNode* playlists = NULL;
    xmlNode* part_node = NULL;
	GList*   part_list = NULL;

	xmlNode* root_node = (xmlNode*)((unsigned int)shm_index->session + (unsigned int)core->song);
	//printf("get_region_list(): shm_index=%p session=%p root_node=%p.\n", shm_index, shm_index->session, root_node);
	if((playlists = DAE::get_named_child(root_node->children, "Playlists"))){ //get the Routes node.
		//printf("get_playlist_list(): playlists node: %p\n", playlists);
		if (!playlists->children) return NULL;
			//for (playlist = playlists->children; playlist; playlist = playlists->next ? (xmlNode*)playlists->next : NULL) {    //gets stuck if we use this loop.
			playlist = playlists->children;
			if (playlist->type == XML_ELEMENT_NODE && playlist->children){
				for (part_node = playlist->children; part_node; part_node = part_node->next ? (xmlNode*)part_node->next : NULL) {
					printf("get_playlist_nodelist():   part node: %p\n", part_node);
					//if (!track_node) return 0;
					if (part_node->type == XML_ELEMENT_NODE){
						//printf("get_playlist_list():   child name: %s\n", part_node->name);
						xmlNode* region;
						if((region = DAE::get_named_child(part_node, "Region"))){
							printf("get_playlist_nodelist(): region! (%p)\n", region);
							if (region->type == XML_ELEMENT_NODE){
								//printf("get_playlist_list(): appending...\n");
								part_list = g_list_append(part_list, region);
								printf("get_playlist_nodelist(): part added to list.\n");
							}
						}
					}
				}
				printf("get_playlist_nodelist(): parts done.\n");
			}
		//}
	}
	printf("get_playlist_nodelist(): num parts found: %i\n", g_list_length(part_list));
	return part_list;
}


xmlNode*
get_named_child(xmlNode* node, const char* find_name)
{
	//returns the first child node of the given node with the given name.

	//FIXME we never ask for ->children! sometimes you need to pass node->children as the arg.

	if((unsigned)node < 1024){ printf("error! get_named_child(): bad node arg (%p).\n", node); return NULL; }

	//printf("get_named_child(): '%s'\n", find_name);

    xmlNode* cur_node;
    for (cur_node = node; cur_node; cur_node = cur_node->next ? (xmlNode*)cur_node->next : NULL) {
        if (cur_node->type == XML_ELEMENT_NODE) {
            //printf("get_named_child(): node type: Element, name: %s\n", cur_node->name);
			if (!strcmp((char*)cur_node->name, (char*)find_name)) {
				//printf("sml_get_named_child(): found!*********************\n");
				return cur_node;
			}
        }
    }
	printf("get_named_child(): '%s' not found.\n", find_name);
	return NULL;
}


guint64
node_get_id(xmlNode* node)
{
	//POINTER_OK_FALSE("node_get_id", node, "node");

	printf("node_get_id()...\n");

	xmlAttr* attr = node->properties;

    xmlAttr* cur_attr = NULL;
    for (cur_attr = attr; cur_attr; cur_attr = cur_attr->next ? (xmlAttr*)cur_attr->next : NULL) {
		//printf("sml_print_attributes():   type=%u children=%p next=%p\n", cur_attr->type, cur_attr->children, cur_attr->next);
		if(cur_attr->type == XML_ATTRIBUTE_NODE){
			//printf("sml_print_attributes():   attr=%p name=%s\n", cur_attr, (char*)sml_translate_address((void*)cur_attr->name));

			if(cur_attr->children){
				xmlNode* value_node = cur_attr->children;
				//printf("sml_print_attributes():   child name: %p content=%p\n", value_node->name, value_node->content);
				//if(!is_song_shm((void*)value_node->content)) errprintf("node_get_id(): content not in shm!\n");
				xmlChar* attr_content;
				const xmlChar* attr_name = cur_attr->name;
				attr_content = value_node->content;
				if(!strcmp((char*)attr_name, (char*)"id")){
					guint64 id = g_ascii_strtoull((char*)attr_content, NULL, 10);
					printf("node_get_id(): %s=\"%s\" %Lu %u\n", attr_name, attr_content, id, (unsigned int)id);
					return id;
				}
			}else printf("node_get_id(): attributte has no children!\n");

		}else printf("node_get_id(): not attribute node! attr=%p\n", cur_attr);
		//if(cur_attr->next && !is_song_shm(cur_attr->next)){ errprintf("node_get_id() bad attrib ref: %p", cur_attr->next); break; }
	}

	return 0;
}
#endif

#if 0
AudioRegion*
AD::region_find(xmlNode* p)
{
	/*
	get a region object for the node at the given address.
	*/

	//printf("AD::region_find()...\n");
	printf("AD::%s(): looking for node %p.\n", __func__, p);
	//xmlNode* root = (xmlNode*)((unsigned int)(shm_index->session) + (unsigned int)dsong);

	xmlNode* region_node = NULL;
	GList* region_list = NULL;
	//for(region_list = get_region_list(); region_list; region_list=region_list->next){
	for(region_list = get_playlist_nodelist(); region_list; region_list=region_list->next){
		if(region_list){
			region_node = (xmlNode*)region_list->data;
			//printf("AD::region_find(): checking region node %p.\n", region_node);
			if(region_node == p){
				printf("AD::region_find(): found the region node!\n");
				//found! how to get &Region?
				guint64 id = node_get_id(region_node);

				//iterate over all Regions to find the one with our id....!!!??

				/*
					audio_regions is a private member of Session:
					map<ARDOUR::id_t,AudioRegion *> audio_regions
				*/

				cout << "AD::region_find(): iterating over audioregion list... id=" << id << endl;
				//for (Playlist::RegionList::iterator x = regions.begin(); x != regions.end(); ++x) {
				//for (Playlist::RegionList::iterator x = session->audio_regions.begin(); x != session->audio_regions.end(); ++x) {
				for (Session::AudioRegionList::iterator x = session->audio_regions.begin(); x != session->audio_regions.end(); ++x) {
					//return (ARDOUR::AudioRegion*)(*x); //return the first one...
					return (*x).second; //return the first one...
				}

				//session->foreach_audio_region (this, &Editor::insert_into_tmp_audio_regionlist);
				//Session::foreach_audio_region(this, &AD::region_foreach); // *********************************************

				//int region_name (string& result, string base = string(""), bool newlevel = false) const; //this looks like its to find a name for a new region.
			}
			else printf("AD::region_find(): region!=p (%p)\n", region_node);
		}
	}
	printf("AD::region_find(): failed to get playlist! playlist=%p\n", get_playlist_nodelist());

	return NULL;
}
#endif

} //end namespace DAE
